=== old_docs/Makefile ===
default:
	@echo 'No default target defined in this Makefile'

clean:
	rm -f pasdoc.aux pasdoc.log pasdoc.toc pasdoc.dvi
