=== debian/changelog ===
pasdoc (0.16.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    See-also: https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html
  * Update standards version to 4.5.1, no changes needed.
    Changes-By: lintian-brush
    Fixes: lintian: out-of-date-standards-version
    See-also: https://lintian.debian.org/tags/out-of-date-standards-version.html

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 01 Nov 2021 11:28:55 +0100

pasdoc (0.16.0-1) experimental; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Repository.

  [ Abou Al Montacir ]
  * Fixed watch file after upstream URL changed.
  * New upstream version 0.16.0
  * Removed patches integrated by upstream.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 10 Apr 2021 17:49:06 +0200
