=== debian/control ===
Source: pasdoc
Section: doc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders: Paul Gevers <elbrus@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
 fp-compiler,
 fp-units-fcl,
 graphviz,
 help2man,
 latex2html,
 libjs-jquery,
 libxml2-utils,
 opensp,
 texlive-latex-base
Standards-Version: 4.5.1
Homepage: https://github.com/pasdoc/pasdoc/wiki
Vcs-Browser: https://salsa.debian.org/pascal-team/pasdoc
Vcs-Git: https://salsa.debian.org/pascal-team/pasdoc.git

Package: pasdoc
Architecture: any
Depends: ${misc:Depends},
Description: documentation tool for Pascal source code
 Pasdoc generates documentation for Pascal units. It takes descriptions from
 comments within the source code. Documentation output formats include HTML and
 LaTeX. Object Pascal, FreePascal and Delphi specific features are supported.
 .
 Pasdoc has the follow features:
  * Understands code written in any Pascal and Object Pascal dialect
  * Understands modern Object Pascal language, as found in latest FreePascal
    and Delphi versions
  * Many output formats: HTML, HTMLHelp, LaTeX (PDF, PS), latex2rft, XML
  * Command-line (in batch mode) and GUI interface
  * Documentation from comments in the source code and/or provided in separate
    file
  * Arbitrary (even optional) comment markers
  * Special @-tags for formatting the documentation
  * Whole pages (like introduction to the docs) can be written using @-tags
  * Easy search box in HTML output using Tipue
  * Classes and unit dependency graphs
  * Optional automatic linking of identifiers
  * Spell checking
  * Cache for generating documentation fast
