=== debian/watch ===
version=4
opts=\
compression=xz,\
repack,\
repacksuffix=+dfsg,\
uversionmangle=s/-/~/,\
dversionmangle=s/\+dfsg(\d*)//,\
"filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pasdoc-$1.tar.xz%" \
	https://github.com/pasdoc/pasdoc/tags \
	(?:.*?/)?v?@ANY_VERSION@\.tar\.gz debian
